package functions;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class CosineSimilarity {
    Map<Byte, int[]> vectorMap = new HashMap<Byte, int[]>();
    int[] tempArray = null;

//    public static void main(String[] args) {
//        byte[] str1 = {36,23};
//        byte[] str2 = {36,23};
//        System.out.println(correlation(str1,str2));
//    }
    public static double CosineSimilarity1(byte[] string1, byte[] string2){
        CosineSimilarity similarity = new CosineSimilarity(string1, string1);
        double result = similarity.sim();
        return result;
    }
    public CosineSimilarity(byte[] string1, byte[] string2) {
        for (byte character1 : string1.clone()) {
            if (vectorMap.containsKey(character1)) {
                vectorMap.get(character1)[0]++;
            } else {
                tempArray = new int[2];
                tempArray[0] = 1;
                tempArray[1] = 0;
                vectorMap.put(character1, tempArray);
            }
        }
        for (Byte character2 : string2.clone()) {
            if (vectorMap.containsKey(character2)) {
                vectorMap.get(character2)[1]++;
            } else {
                tempArray = new int[2];
                tempArray[0] = 0;
                tempArray[1] = 1;
                vectorMap.put(character2, tempArray);
            }
        }
    }
    // 求余弦相似度
    public double sim() {
        double result = 0;
        result = pointMulti(vectorMap) / sqrtMulti(vectorMap);
        return result;
    }
    private double sqrtMulti(Map<Byte, int[]> paramMap) {
        double result = 0;
        result = squares(paramMap);
        result = Math.sqrt(result);
        return result;
    }
    // 求平方和
    private double squares(Map<Byte, int[]> paramMap) {
        double result1 = 0;
        double result2 = 0;
        Set<Byte> keySet = paramMap.keySet();
        for (Byte character : keySet) {
            int temp[] = paramMap.get(character);
            result1 += (temp[0] * temp[0]);
            result2 += (temp[1] * temp[1]);
        }
        return result1 * result2;
    }
    // 点乘法
    private double pointMulti(Map<Byte, int[]> paramMap) {
        double result = 0;
        Set<Byte> keySet = paramMap.keySet();
        for (Byte character : keySet) {
            int temp[] = paramMap.get(character);
            result += (temp[0] * temp[1]);
        }
        return result;
    }
}