import entities.Code;
import entities.SymbolMap;
import functions.DataEncoding;
import functions.SymbolMapping;
import tools.*;

import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


public class testseach {

    public static void main(String[] args) {
        //Set timer
        long time = 0;
        //Progress settings
        Runnable rt = ()->{
            while(true) {
                try {
                    Thread.sleep(10000);
                }catch(InterruptedException e) {
                    e.printStackTrace();
                }
                System.out.println(Configurator.progress[0] + "/" + Configurator.progress[1]);
            }
        };

        System.out.println("Start Experiment: Correctness: Test 1...");
        //Load configuration
        Configurator.loadConf("testseach.txt");
        //Start progress monitor
        new Thread(rt).start();
        //Run test
        time = System.currentTimeMillis();
        testseach.testseach1();
        System.out.println("Run time: " + (System.currentTimeMillis() - time));
        System.exit(0);
    }

    public void writeArrayToTxt(byte[] data, String string) {
        int rowNum = data.length;
//        int columnNum = data[0].length;
        try {
            FileWriter fw = new FileWriter(string);
//            for (int i = 0; i < rowNum; i++) {
//                for (int j = 0; j < columnNum; j++)
//                    fw.write(data[i][j]+ "\t");
//                fw.write("\n");
//            }
            for (int i = 0; i < data.length; i++) {
			    fw.write(data[i]+"\t");//读取一个数字,就写入文件一次
                if (i % 20 == 0  && i != 0){
                    fw.write("\n");
                }
		    }
            fw.close();
        }
        catch (IOException e){
            e.printStackTrace();
        }
    }

    // 导出到 excel的代码其实跟导出到 txt 的代码一样
    public void writeArrayToExcel(double[][] data, String string) {
        int rowNum = data.length;
        int columnNum = data[0].length;
        try {
            FileWriter fw = new FileWriter(string);
//            for (int i = 0; i < rowNum; i++) {
//                for (int j = 0; j < columnNum; j++)
//                    fw.write(data[i][j]+ "\t"); // tab 间隔
//                fw.write("\n"); // 换行
//            }
            for (int i = 0; i < data.length; i++) {
                fw.write(data[i]+"\t");//读取一个数字,就写入文件一次
                if (i % 20 == 0  && i != 0){
                    fw.write("\n");
                }
            }
            fw.close();
        }
        catch (IOException e){
            e.printStackTrace();
        }

    }


    public static void testseach1() {
        //Set progress
        Configurator.progress[1] = Configurator.CdF + Configurator.CdF * 2 * Configurator.epsilon.length * Configurator.sigma.length;
        //Create key pairs
        HashMap<String, String> keyPairs = ECDSA.getECDSAKeyPairsHash(Configurator.users); //1
        System.out.println(keyPairs.size());
        //Data preparation
        byte[] d = new byte[Integer.parseInt(Configurator.volume[0])];
        for(int i = 0; i < d.length; i ++) {
            d[i] = (byte) Randomizer.randomInt(0, 256);
        }
        testseach wa = new testseach();
        wa.writeArrayToTxt(d, "D:/data/mytxt.txt");
        wa.writeArrayToTxt(d, "D:/data/mytxt.xls");

        //System Parameters
        double gamma = Double.parseDouble(Configurator.gamma[0]);
        int tau = Integer.parseInt(Configurator.tau[0]);
        int lambda = Integer.parseInt(Configurator.lambda[0]);
        int presTheta = Integer.parseInt(Configurator.presTheta[0]);
        int presEta = Integer.parseInt(Configurator.presEta[0]);
        double r = Configurator.r;

        //Mappings and Embedding
        HashMap<String, SymbolMap> maps = new HashMap<String, SymbolMap>(); //<F, map>
        HashMap<String, Code> dFs = new HashMap<String, Code>(); //<F, dF>
        for(Map.Entry<String, String> entry : keyPairs.entrySet()) {
            //Prepare hSK
            String hPK = entry.getKey();
            String hSK = entry.getValue();
            //Prepare F
            byte[] F = Converter.Hex2byte(hPK);
            //Mapping
            SymbolMap map = SymbolMapping.createSymbolMap(d, hSK, F, gamma, tau, presTheta, presEta, lambda);
            map.phi = Configurator.phi;
            map.chi = Configurator.chi;
            maps.put(hPK, map);
            //Embedding
            byte[] dF = DataEncoding.encodeData(d, map, F);
            Code cdF = new Code(dF);
            dFs.put(hPK, cdF);
            //Update progress
            Configurator.progress[0] ++;
        }

        //testseach
        for(int j = 0; j < Configurator.epsilon.length; j ++) { //j=1
            double epsilon = Double.parseDouble(Configurator.epsilon[j]); //0.4
            for(int k = 0; k < Configurator.sigma.length; k ++) {  //k=1
                int sigma = Integer.parseInt(Configurator.sigma[k]); //12
                byte[] arr = null;
                //根据带指纹的数据查找
                for(Map.Entry<String, Code> entry : dFs.entrySet()) {
                    //得到编码数据
                    byte[] dF = entry.getValue().getData();
//                    for(int m=0;m<dF.length;m++) {
//						System.out.print(dF[m] + " ");
//					}
                    HashMap<String, SymbolMap> f_maps = new HashMap<String, SymbolMap>();
                    //找到带指纹数据的用户
                    String hPK = entry.getKey();  //得到公钥
                    f_maps.put(hPK, maps.get(hPK));  //将公钥和符号映射表加入f_maps
                    int size = f_maps.values().size();
                    for(Map.Entry<String, SymbolMap> f_map : f_maps.entrySet()) {
                        SymbolMap map = f_map.getValue(); //得到符号映射表
                        //得到符号映射表的符号和明码部分，Map+，
//                        HashMap<Code, Code> sp = map.getMapS();  //<p, s> Secret part of the symbol map.
//                        List<Code> S = (List<Code>) sp.values();
//                        System.out.print(S.size());
//                        for(int i=0;i<S.size();i++) {
//                            System.out.print(S);
//                        }
                        ArrayList<Code> S = map.getSs();//根据符号映射表得到符号
                        System.out.println(S.size()); //27794
                        for(int i=0;i<S.size();i++) {
//                            System.out.print(S.get(i).getData());
                            byte[] s = S.get(i).getData();//得到下标对应的数值
                            arr = Calculator.concatArrays(arr, s);//将这个值加入到dFStar
                        }
                    }
                }
                testseach ts = new testseach();
                ts.writeArrayToTxt(arr, "D:/data/mytxt1.txt");
                ts.writeArrayToTxt(arr, "D:/data/mytxt1.xls");
            }
        }

    }
}